<?	

/*
 * Copyright 2012 Junta de Extremadura, España
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*
* Licencia con arreglo a la GPL, Versión 2 o  versiones posteriores de la GPL (GPL2);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en:
*
* http://www.gnu.org/licenses/gpl-2.0.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, el programa distribuido con arreglo a la Licencia se distribuye "TAL CUAL",
* SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.

* Autor original: Consejería de Educación y Cultura de la Junta de Extremadura, Educonsulting/Micromedia
 */

	include("./gestorlocal/classes/class.XMLLikeFlash.php");
	include "./gestorlocal/classes/class.infodirectorios.php";

	

	class ReinstanciadorUnidades{
	
		var $SUMA_SEMILLA = 0; //DEBERIA SER EL MAYOR DE LAS INSTANCIAS
		
		var $NOMBRE_OA = "";
		var $DIRECTORIO_OA ;
		var $DIRECTORIO_OA_XML;
		var $DIRECTORIO_OA_XML_OBJETOS;

		var $SUSTITUCIONES_NOMBRES_XML_OBJETOS = array();		
		var $SUSTITUCIONES_ETIQUETAS_FOTOGRAMAS = array();
		var $SUSTITUCIONES_NOMBRES_OBJETOS = array();
		
		var $SEMILLA_FOTOGRAMA;
		var $SEMILLA_OBJETO;
		
		var $debug = FALSE;
		var $fichero_debug = "debug_importar_reinstanciar.txt";
		
		function ReinstanciadorUnidades($nombre_oa,$dir_oa,$ultima_instancia){
			
			//die("PETER");
			$this->NOMBRE_OA = $nombre_oa;
			$this->DIRECTORIO_OA = $dir_oa."/".$this->NOMBRE_OA."/";
			$this->DIRECTORIO_OA_XML = $this->DIRECTORIO_OA."XML/";
			$this->DIRECTORIO_OA_XML_OBJETOS = $this->DIRECTORIO_OA."XML/objetos";
			
			$this->SUMA_SEMILLA = $ultima_instancia;
			$this->SEMILLA_FOTOGRAMA = rand(0,999) + $this->SUMA_SEMILLA;
			$this->SEMILLA_OBJETO = $this->SEMILLA_FOTOGRAMA;
			$xml_curso = $this->DIRECTORIO_OA."curso.xml";
			$xml_curso = str_replace("//","/",$xml_curso);
			$this->debugear("PROCESO=>".$xml_curso);
			if(file_exists($xml_curso)){
				$this->procesarCurso($xml_curso);
			}
		}
		//print_r($SUSTITUCIONES_ETIQUETAS_FOTOGRAMAS);
		
		function procesarCurso($xml_curso){
			//print("EOO");
			$reader = new XMLLikeFlash($xml_curso);
			$hijos = $reader->firstChild()->childNodes();
			for($i=1;$i<count($hijos);$i++){
				$xml_pantalla = $hijos[$i]->attributes('XML');
				$xml_pantalla = $this->DIRECTORIO_OA_XML."/".$xml_pantalla;
				$this->procesarPantalla($xml_pantalla);		
				$this->debugear("Escrita pantalla: ".$xml_pantalla);				
			}
			$this->procesar_todos_objetos($this->SUSTITUCIONES_NOMBRES_XML_OBJETOS,$this->DIRECTORIO_OA_XML_OBJETOS);
			$this->renombrar_archivos_xml($this->SUSTITUCIONES_NOMBRES_XML_OBJETOS,$this->DIRECTORIO_OA_XML_OBJETOS);
			//print("OK");
		}
		
		
		function debugear($cadena){
			if($this->debug==TRUE){
				$f = fopen($this->fichero_debug,"a");
				fwrite($f,$cadena."\r\n");
				fclose($f);
			}
		}
		
		function procesarPantalla($xml_pantalla){
			//die($xml_pantalla);
			$reader = new XMLLikeFlash($xml_pantalla);
			$hijos = $reader->firstChild()->childNodes();
			for($i=0;$i<count($hijos);$i++){
				$xml_fotograma = $hijos[$i]->attributes('XML');	
				$this->procesarFotograma($this->DIRECTORIO_OA_XML.$xml_fotograma);
				$this->debugear("Escrito Fotograma: ".$xml_fotograma);
			}
		}
		
		function procesarFotograma($xml_fotograma){
					
			//print "PROCESO=>".$xml_fotograma."<br>";
			$reader = new XMLLikeFlash($xml_fotograma);
			$hijos = $reader->firstChild()->childNodes();
			$etiqueta_fotograma = $hijos[0]->attributes("ETIQUETA");
			$nueva_etiqueta = $etiqueta_fotograma."_".$this->SEMILLA_FOTOGRAMA;
			$this->SUSTITUCIONES_ETIQUETAS_FOTOGRAMAS[$etiqueta_fotograma] = $nueva_etiqueta;
			$hijos[0]->setAttribute("ETIQUETA",$nueva_etiqueta);
			
			for($i=2;$i<count($hijos);$i++){
				$xml_objeto = $hijos[$i]->attributes("XML");
				$this->debugear("Escrito Objeto: ".$xml_objeto);
				//print(substr($xml_objeto,0,strlen($xml_objeto)-4)."<br>-------------------");
				$nuevo_nombre_xml = substr($xml_objeto,0,strlen($xml_objeto)-4).$this->SEMILLA_OBJETO.".xml";
				$this->SUSTITUCIONES_NOMBRES_XML_OBJETOS[$xml_objeto] = $nuevo_nombre_xml;
				$hijos[$i]->setAttribute("XML",$nuevo_nombre_xml);
				//procesarObjeto($DIRECTORIO_OA_XML_OBJETOS."/".$xml_objeto);
				//print("ASDASD".$xml_objeto)."<br>";
				$nombre_objeto = $hijos[$i]->attributes("NAME");			
				$this->SUSTITUCIONES_NOMBRES_OBJETOS[$nombre_objeto] = $nombre_objeto.$this->SEMILLA_OBJETO;
				$hijos[$i]->setAttribute("NAME",$nombre_objeto.$this->SEMILLA_OBJETO);
			}
			$reader->escribirFichero();
			//print_r($SUSTITUCIONES_NOMBRES_XML_OBJETOS);
			//print("<br>");
		}
		
		
		function procesarObjeto($xml_objeto){
		
			//print("<br>OBJETO=>".$xml_objeto);
			$reader = new XMLLikeFlash($xml_objeto);
			$hijos = $reader->firstChild();
			$this->procesarEventos($this->SUSTITUCIONES_NOMBRES_OBJETOS,$hijos);
			$this->procesarEnlaces($this->SUSTITUCIONES_ETIQUETAS_FOTOGRAMAS,$hijos);
			$this->procesarIra($this->SUSTITUCIONES_ETIQUETAS_FOTOGRAMAS,$hijos);
			$reader->escribirFichero();
		}
			
		function renombrar_archivos_xml($array_xmls,$ruta){
			
			$claves = array_keys($array_xmls);
			$valores = array_values($array_xmls);
			
			for($i=0;$i<count($array_xmls);$i++){
				$origen = $ruta."/".$claves[$i];
				$destino = $ruta."/".$valores[$i];
				//print("RENOMBRO=>".$origen."=>".$destino."<br>");
				rename($origen,$destino);
			}	
		}
		
		function procesar_todos_objetos($array_xmls,$ruta){
			
			$claves = array_keys($array_xmls);
			//$valores = array_values($array_xmls);
			
			for($i=0;$i<count($array_xmls);$i++){
				$xml_objeto = $ruta."/".$claves[$i];
				//$destino = $ruta."/".$valores[$i];
				$this->procesarObjeto($xml_objeto);
			}	
		}


		
		function procesarEventos($tabla_sustituciones_objetos,$xml){
			$eventos = $xml->getChildByName("EVENTOS");
			if($eventos==null){
				die("ERROR, OBJETO SIN EVENTOS");
			}
			$loseventos = $eventos->childNodes();
			for($i=0;$i<count($loseventos);$i++){
				$evento_actual = $loseventos[$i];
				$acciones_del_evento = $evento_actual->childNodes();
				for($j=0;$j<count($acciones_del_evento);$j++){
					$accion_actual = $acciones_del_evento[$j];
					$victima = $accion_actual->attributes('VICTIMA');
					if(isset($tabla_sustituciones_objetos[$victima])==1){
						$accion_actual->setAttribute('VICTIMA',$tabla_sustituciones_objetos[$victima]);
					}
				}
			}
		}
		
		function procesarEnlaces($tabla_sustituciones_fotogramas,$xml){
			$enlaces = $xml->getChildByName("ENLACES");
			if($enlaces==null){
				die("ERROR, OBJETO SIN ENLACES");
			}
			$loslink= $enlaces->childNodes();		
			for($j=0;$j<count($loslink);$j++){
				$link_actual = $loslink[$j];
				$destino = $link_actual->attributes('DESTINO');
				
				$tipo_destino = substr($destino,0,2);
				if($tipo_destino=="F%"){
					$destino_real = substr($destino,2);
					if(isset($tabla_sustituciones_fotogramas[$destino_real])==1){
						$link_actual->setAttribute('DESTINO',$tipo_destino.$tabla_sustituciones_fotogramas[$destino_real]);
					}
				}		
			}		
		}
		
		function procesarIra($tabla_sustituciones_fotogramas,$xml){
			$ira = $xml->getChildByName("IRA");
			if($ira==null){
				return;
			}
			$destino_real = $ira->attributes('etiqueta');
			if(isset($tabla_sustituciones_fotogramas[$destino_real])==1){
				$ira->setAttribute('etiqueta',$tabla_sustituciones_fotogramas[$destino_real]);
			}					
		}
	}
	
?>