<?

/*
 * Copyright 2012 Junta de Extremadura, España
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*
* Licencia con arreglo a la GPL, Versión 2 o  versiones posteriores de la GPL (GPL2);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en:
*
* http://www.gnu.org/licenses/gpl-2.0.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, el programa distribuido con arreglo a la Licencia se distribuye "TAL CUAL",
* SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.

* Autor original: Consejería de Educación y Cultura de la Junta de Extremadura, Educonsulting/Micromedia
 */

/*
 * EJEMPLO DE USO:
 * 			$reader = new XMLLikeFlash($xml_curso);
			$hijos = $reader->firstChild()->childNodes();
			for($i=0;$i<count($hijos);$i++){
				$xml_pantalla = $hijos[$i]->attributes('XML');
				$kk = $hijos->getChildByName("leches");
				$kk2 = $kk->attributes('ATRIBUTO');	
				$kk->setAttribute("ATRIBUTO","NUEVO VALOR");
			}
 * 
 * 
 * */
	class XMLLikeFlash{
		
		var $fichero;
		var $array_todo;
		var $xml_node;
		
		function XMLLikeFlash($fichero){
			
			$fichero = str_replace("//","/",$fichero);
			if(!file_exists($fichero)){
				print("NO HAY FICHERO=>".$fichero);
				return;	
			}
			
			$this->fichero = $fichero;
			$xml = new XMLReader();
			$xml->open($fichero);
			$this->array_todo = $this->xml2assoc($xml);
			$xml->close();
			//print("ASDASD");
			//print_r($this->array_todo);			
			$this->xml_node = new XMLNode($this->array_todo);
		}
		
		function toXML(){
			$retorno='<?xml version="1.0" encoding="ISO-8859-1"?>';
			return $retorno.$this->xml_node->firstChild()->toXML();		
		}
		
		function escribirFichero(){
			$contenido_xml = $this->toXML();
			$f = fopen($this->fichero,"wr");
			fwrite($f,$contenido_xml);
			fclose($f);		
		}
		
		function firstChild(){
			return $this->xml_node->firstChild();		
		}
		
			
		function xml2assoc(&$xml){
		    $assoc = NULL;
		    $n = 0;
		    while($xml->read()){
		        if($xml->nodeType == XMLReader::END_ELEMENT) break;
		        if($xml->nodeType == XMLReader::ELEMENT and !$xml->isEmptyElement){
		            $assoc[$n]['name'] = utf8_decode($xml->name);
		            if($xml->hasAttributes) while($xml->moveToNextAttribute()) $assoc[$n]['atr'][$xml->name] = utf8_decode($xml->value);
		            $assoc[$n]['val'] = $this->xml2assoc($xml);
		            $n++;
		        }
		        else if($xml->isEmptyElement){
		            $assoc[$n]['name'] = utf8_decode($xml->name);
		            if($xml->hasAttributes) while($xml->moveToNextAttribute()) $assoc[$n]['atr'][$xml->name] = utf8_decode($xml->value);
		            $assoc[$n]['val'] = "";
		            $n++;                
		        }
		        else if($xml->nodeType == XMLReader::TEXT) $assoc = utf8_decode($xml->value); 
		    }
		    return $assoc;
		}
	}
	
	class XMLNode{
	
		var $child;
		var $name;
		var $atributos;
		
		var $soy_root;
		var $primer_nodo;
		
		function XMLNode($array){
			//print_r($array);
			//die();
			//print_r("VAL=>".$array['val'].",".isset($array['val'])."<=<br><br>");
			if($this->esElementoRoot($array)==FALSE){
				//print("NO SOY ROOT");
				$this->soy_root = FALSE;
				$this->atributos = $array['atr'];
				$this->child = $this->arrayToArrayNodes($array['val']);
				$this->name = $array['name'];				
			}
			else{
			//	print("SOY ROOT");
				$this->soy_root = TRUE;
				$this->primer_nodo = new XMLNode($array[0]);
			}	
			//die();			
		}
		
		function getChildByName($nombre){
						
			if($this->isTextNode()){
				return null;
			}
			$hijos = $this->childNodes();
			for($i=0;$i<count($hijos);$i++){
				$nombre_hijo = $hijos[$i]->nodeName();
				//print $nombre_hijo;
				if($nombre_hijo==$nombre){
					return $hijos[$i];
				}			
			}
			return null;
		}
		
		function esElementoRoot($array){
			$claves = array_keys($array);
			//print_r($claves);
			for($i=0;$i<count($claves);$i++){
				if($claves[$i].""=="val"){
					//print("NO ES ROOT=>".$claves[$i]);
					return FALSE;
				}
			}
			return TRUE;
		}
		
		
		function toXML(){
			
			$retorno = "<".$this->nodeName();
			//print $retorno;
			$atributos = $this->getAllAtributes();
			if(count($atributos)>0){
				$claves = array_keys($atributos);
				$valores = array_values($atributos);
				
				for($i=0;$i<count($atributos);$i++){				
					$clave = $claves[$i];
					$valor = $this->quitapicosycomillas($valores[$i]);
					$retorno.= " ".$clave.'="'.$valor.'"';
				}
			}
			if($this->isTextNode()){
				$retorno.=">";	
				$retorno.=$this->quitapicosycomillas($this->child);
				$retorno.="</".$this->nodeName().">";
			}
			else{
				if($this->hasChildNodes()){
					$retorno.=">";			
					$hijos = $this->childNodes();
					for($i=0;$i<count($hijos);$i++){
						$retorno.= $hijos[$i]->toXML();
					}
					$retorno.="</".$this->nodeName().">";
				}
				else{
					$retorno.="/>";
				}
			}
			return $retorno;
		}
		
		
		function isTextNode(){
			if(!is_array($this->child) && $this->child!=''){
				return TRUE;
			}
			return FALSE;
		}
		
		function hasChildNodes(){
			return count($this->child)>0 && is_array($this->child);
		}
		
		function attributes($nombre){
			return $this->atributos[$nombre];
		}
		
		function getAllAtributes(){
			return $this->atributos;
		}
		
		function setAttribute($nombre,$valor){
			$this->atributos[$nombre] = $valor;	
			return;
		}
		
		function nodeName(){
			return $this->name;
		}
		
		function childNodes(){
			if(is_array($this->child)){
				return $this->child;
			}
			return array();
		}
		
		function firstChild(){
			if($this->soy_root==TRUE){
				return $this->primer_nodo;
			}
			else{
				//print_r($this->array_todo[0]);
				return $this->child[0];
			}
		}
		
		function nodeValue($valor){
			if(isset($valor)){
				$this->child = $valor;
			}
			else{
				return $this->child;
			}
		}
		
			
		function arraytostring($array, $depth = 0)
		{
		   if($depth > 0)
		      $tab = implode('', array_fill(0, $depth, "\t"));
		   $text.="array(\n";
		   $count=count($array);

		   foreach ($array as $key=>$value)
		   {
		       $x++;

		       if (is_array($value))
		       {
		           if(substr($text,-1,1)==')')    $text .= ',';
		           $text.=$tab."\t".'"'.$key.'"'." => ".arraytostring($value, $depth+1);
		           continue;
		       }

		       $text.=$tab."\t"."\"$key\" => \"$value\"";

		       if ($count!=$x) $text.=",\n";
		   }

		   $text.="\n".$tab.")\n";

		   if(substr($text, -4, 4)=='),),')$text.='))';

		   return $text;
		}
		
		
		function arrayToArrayNodes($array){
		
			if(!is_array($array)){ //SI ES UN NODO DE TEXTO
				//die("!!!!!!=>".$array);
				return $array;
			}
			$retorno = array();
			for($i=0;$i<count($array);$i++){
				//print_r($array[$i]);
				array_push($retorno,new XMLNode($array[$i]));
			}
			return $retorno;
		}
		
		
		function quitapicosycomillas($cadena){
			$cadena = str_replace("<","&lt;",$cadena);
			$cadena = str_replace(">","&gt;",$cadena);
			$cadena = str_replace('"',"&quot;",$cadena);
			return $cadena;
		}
		
	}



?>