<?

/*
 * Copyright 2012 Junta de Extremadura, España
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*
* Licencia con arreglo a la GPL, Versión 2 o  versiones posteriores de la GPL (GPL2);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en:
*
* http://www.gnu.org/licenses/gpl-2.0.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, el programa distribuido con arreglo a la Licencia se distribuye "TAL CUAL",
* SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.

* Autor original: Consejería de Educación y Cultura de la Junta de Extremadura, Educonsulting/Micromedia
 */

include_once "class.xmloa.php";
include_once "lib.xml.php";

class xmlsd{


	var $nombre;
	var $nivel;
	var $fichero;
	var $oas = array();

	function xmlsd($fichero){
		$this->fichero = $fichero;
		$this->leer_xml();
		$oas = array();
	}

	function toXML(){
		$retorno = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>";
		$retorno.= "<sd>";
		$retorno.= "<nombre>$this->nombre</nombre>";
		$retorno.= "<nivel>$this->nivel</nivel>";
		$retorno.= "<oas>";
		for($i=0;$i<count($this->oas);$i++){
			$oa = $this->oas[$i];
			$retorno.= $oa->toXML();
		}
		$retorno.= "</oas>";
		$retorno.= "</sd>";
		return $retorno;
	}


	function cambiar_longitud($path,$longitud){
		for($i=0;$i<count($this->oas);$i++){
			$oa = $this->oas[$i];
			//print("COMPARO=".$path." CON=".$oa->path."<br>");
			if($oa->path == $path){
				//die("SI");
				$oa->longitud = $longitud;
			}
		}
	}

	function cambiar_nombre($path,$nombre){
		for($i=0;$i<count($this->oas);$i++){
			$oa = $this->oas[$i];
			
			if($oa->path == $path){
				$oa->nombre = $nombre;
			}
		}
	}

	function meter_oa($nombre,$path,$longitud){
		$oa = new xmloa($nombre,$path,$longitud);
		array_push($this->oas,$oa);
		return;
	}

	function borrar_oa($path){
		for($i=0;$i<count($this->oas);$i++){
			$oa = $this->oas[$i];
			if($oa->path == $path){
				array_splice($this->oas,$i,1);
			}
		}
	}


	function leer_xml(){
		$xml = new Xml;
		$out = $xml->parse($this->fichero,'FILE','UTF-8');
		//print_r($out);
		//die();
		
		if(is_array($out['nombre'])){
			$salida = "";
			for($i=0;$i<count($out['nombre']);$i++){
				$salida.= $out['nombre'][$i];
			}
			$this->nombre = $salida;
		}
		else{
			$this->nombre = $out['nombre'];
		}
		
		if(is_array($out['nivel'])){
			$salida = "";
			for($i=0;$i<count($out['nivel']);$i++){
				$salida.= $out['nivel'][$i];
			}
			$this->nivel = $salida;
		}
		else{
			$this->nivel = $out['nivel'];
		}
		
		
		$oasxml = $out['oas']['oa-ATTR'];
		//print_r($oasxml);
		ini_set("display_errors",0);
		if(array_key_exists('NOMBRE',$oasxml)){
			//print("SOLO UNO");
			$nombre = $oasxml['NOMBRE'];
			$path = $oasxml['PATH'];
			$longitud = $oasxml['LONGITUD'];
			$this->meter_oa($nombre,$path,$longitud);
			//print ("METO=".$nombre."<br>");
		}
		else{
			if(isset($oasxml[0]['NOMBRE'])){
				//print "AKI";
				for($i=0;$i<count($oasxml);$i++){
					$nombre = $oasxml[$i]['NOMBRE'];
					$path = $oasxml[$i]['PATH'];
					$longitud = $oasxml[$i]['LONGITUD'];
					$this->meter_oa($nombre,$path,$longitud);
					//print ("METO=".$nombre."<br>");
				}
			}
		}
		//print("SALGO<br>");
	}

	function escribir_xml(){
		$fh = fopen($this->fichero,"wb");
		// adding header 
		$text="\xEF\xBB\xBF";
		fwrite($fh,$text.($this->toXML()));
		fclose($fh);
	}


	function getNombreAt($i){
		return $this->oas[$i]->nombre;
	}

	function getPathAt($i){
		return $this->oas[$i]->path;
	}

	function getLongitudAt($i){
		return $this->oas[$i]->longitud;
	}

	function getTamano(){
		return count($this->oas);
	}

	function length(){
		return count($this->oas);
	}


}
?>