<?

/*
 * Copyright 2012 Junta de Extremadura, España
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*
* Licencia con arreglo a la GPL, Versión 2 o  versiones posteriores de la GPL (GPL2);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en:
*
* http://www.gnu.org/licenses/gpl-2.0.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, el programa distribuido con arreglo a la Licencia se distribuye "TAL CUAL",
* SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.

* Autor original: Consejería de Educación y Cultura de la Junta de Extremadura, Educonsulting/Micromedia
 */

function xml_metadata_escribe_element($tag, $value, $arrayattrib = NULL){
	$salida="\t<$tag";
	if ($arrayattrib){
		foreach ($arrayattrib as $attrib){
			$salida.=" $attrib";
		}	
	}
	$salida.=">$value</$tag>\n";
	return $salida;
}

function xml_tagopen($tag){
	return "<$tag>\n";
}
function xml_tagclose($tag){
	return "</$tag>\n";
}


function xml_metadata_escribe_langstrings($tag, $array){
	$salida="\t<$tag>\n";

	foreach($array as $key => $value){
		if (!$key || !$value)
		  $salida.="\t\t<langstring>$value</langstring>\n";
		else 
		  $salida.="\t\t<langstring xml:lang=\"$key\">$value</langstring>\n";
	}
		
	$salida.="\t</$tag>\n";
	return $salida;
}


function xml_metadata_get_entity($tag, $in_array, $depth=NULL){
	$tag_start=999999;
	$tag_end=0;
	
	$salida=array();
	/*separamos los trozos que nos interesan */
	for ($i=0;$i<count($in_array);$i++){
		if ($in_array[$i]["tag"]==strtoupper($tag) && $in_array[$i]["type"] == "open"){
			if ($depth && $in_array[$i]["level"]!=$depth){
				continue;
			}
			$tag_start=$i;
		}
		if ($in_array[$i]["tag"]==strtoupper($tag) && $in_array[$i]["type"] == "close"){
			if ($depth && $in_array[$i]["level"]!=$depth){
				continue;
			}
			$tag_end=$i+1;
			$temp_data = array_slice($in_array, $tag_start, $tag_end-$tag_start);
			array_push($salida, $temp_data);
		}
	}
	
	return $salida;
}

function xml_metadata_lee_valor($tag, $in_array, $depth=NULL){
	
	foreach ($in_array as $entry){
		if (!($depth && $entry["level"]!=$depth)){
			if ($entry["tag"]==strtoupper($tag) && $entry["type"]=="complete"){
				return $entry["value"]; 
				break;
			}
		}
	}
	return NULL;
}

function xml_metadata_lee_langstring($tag, $in_array, $depth=NULL){
	
	/*separamos el trozo que nos interesa */
	$temp_data = xml_metadata_get_entity($tag, $in_array, $depth);
	
	if (!$temp_data)
		return NULL;
	return xml_metadata_lee_valor("langstring", $temp_data[0]);
	
	return NULL;
}

function xml_metadata_lee_valor_diccionario($tag, $in_array){
	/*separamos el trozo que nos interesa*/
	$temp_data = xml_metadata_get_entity($tag, $in_array,$depth=NULL);
	/* devolvemos el langstring de value */
	return xml_metadata_lee_langstring("VALUE", $temp_data[0],$depth);
}


?>